#Makefil for 2D electrostatic PIC code with open (vacuum)
#boundary conditions based on the UPIC Framework

# Makefile g95 compiler with OpenMPI and MacOS X

MPIFC = mpif90
#MPIFC = mpif77
FC90 = g95
FC77 = g77

OPTS90 = -O3 -fno-second-underscore
OPTS77 = -O3 -fno-second-underscore
#OPTS90 = -O3 -r8 -fno-second-underscore
#OPTS77 = -O3 -r8 -fno-second-underscore
MOPTS =
# MOPTS = -fstatic
LOPTS =
LEGACY =

LIBS = -lSystemStubs

# Makefile IBM compiler with LAM MPI and MacOS X

#MPIFC = mpif77
#FC90 = xlf90
#FC77 = xlf

#OPTS90 = -O3 -qautodbl=dbl4 
#OPTS77 = -O3 -qautodbl=dbl4 -qfixed
#MOPTS = -s
#LOPTS =
#LEGACY =

#

LOBJS = lesopenpic2mod.o lesopenpic2lib.o
OBJS = esopenpic2mod.o esopenpic2lib.o

# Linkage rules

all : lesopenpic2f77 lesopenpic2 lesopenpic2main esopenpic2 esopenpic2main

lesopenpic2f77 : lesopenpic2f77.o lesopenpic2lib.o
	$(MPIFC) $(OPTS90) $(LOPTS) lesopenpic2f77.o lesopenpic2lib.o -o lesopenpic2f77

lesopenpic2 : lesopenpic2.o $(LOBJS)
	$(MPIFC) $(OPTS90) $(LOPTS) lesopenpic2.o $(LOBJS) -o lesopenpic2

lesopenpic2main : lesopenpic2main.o lesopenpic2_facade.o $(LOBJS)
	$(MPIFC) $(OPTS90) $(LOPTS) lesopenpic2main.o lesopenpic2_facade.o $(LOBJS) -o lesopenpic2main

esopenpic2 : esopenpic2.o $(OBJS)
	$(MPIFC) $(OPTS90) $(LOPTS) esopenpic2.o $(OBJS) -o esopenpic2

esopenpic2main : esopenpic2main.o esopenpic2_facade.o $(OBJS)
	$(MPIFC) $(OPTS90) $(LOPTS) esopenpic2main.o esopenpic2_facade.o $(OBJS) -o esopenpic2main

# Compilation rules

lesopenpic2lib.o : lesopenpic2lib.f
	$(MPIFC) $(OPTS77) $(LEGACY) -c lesopenpic2lib.f

lesopenpic2mod.o : lesopenpic2mod.f
	$(FC90) $(OPTS90) -c lesopenpic2mod.f

lesopenpic2_facade.o : lesopenpic2_facade.f lesopenpic2mod.o
	$(FC90) $(OPTS90) -c lesopenpic2_facade.f

lesopenpic2f77.o : lesopenpic2f77.f
	$(FC90) $(OPTS77) $(MOPTS) -c lesopenpic2f77.f

lesopenpic2.o : lesopenpic2.f lesopenpic2mod.o
	$(FC90) $(OPTS90) $(MOPTS) -c lesopenpic2.f

lesopenpic2main.o : lesopenpic2main.f lesopenpic2_facade.o
	$(FC90) $(OPTS90) $(MOPTS) -c lesopenpic2main.f

esopenpic2lib.o : esopenpic2lib.f
	$(MPIFC) $(OPTS77) $(LEGACY) -c esopenpic2lib.f

esopenpic2mod.o : esopenpic2mod.f
	$(FC90) $(OPTS90) -c esopenpic2mod.f

esopenpic2_facade.o : esopenpic2_facade.f esopenpic2mod.o
	$(FC90) $(OPTS90) -c esopenpic2_facade.f

esopenpic2.o : esopenpic2.f esopenpic2mod.o
	$(FC90) $(OPTS90) $(MOPTS) -c esopenpic2.f

esopenpic2main.o : esopenpic2main.f esopenpic2_facade.o
	$(FC90) $(OPTS90) $(MOPTS) -c esopenpic2main.f

clean :
	rm -f *.o *.mod

clobber: clean
	rm -f lesopenpic2f77 lesopenpic2 lesopenpic2main esopenpic2 esopenpic2main


